<template>
  <!-- Delete Project Modal -->
  <b-modal
    id="deleteProjectModal"
    v-model="isOpen"
    :hide-footer="true"
    @close="close"
    @hidden="hidden"
  >
    <!-- Title -->
    <template #title>
      <span class="h6"> {{ $t(titleKey) }} </span>
    </template>

    <!-- Body -->
    <div>
      {{ $t(descriptionKey) }}
    </div>

    <b-form-group>
      <!-- Modal Project Display Name -->
      <p class="h6 my-2">
        {{ displayName }}
      </p>

      <!-- Modal Input Text Field -->
      <b-form-input
        v-model="deleteName"
        class="mb-3"
        :state="nameValid"
        :placeholder="displayName"
        required
        @keyup.enter.prevent="clickDelete"
      ></b-form-input>
      <div class="invalid-tooltip">
        {{ $t("page.configMetadata.modal.deleteModalHelp") }}
      </div>
    </b-form-group>

    <!-- Modal Cancel Button -->
    <b-button @click="close">{{ $t("buttons.cancel") }}</b-button>
    <!-- Modal Delete Button -->
    <b-button
      variant="danger"
      class="float-end"
      :disabled="!nameValid"
      @click="clickDelete"
      >{{ $t("buttons.delete") }}</b-button
    >
  </b-modal>
</template>

<script lang="ts">
export default defineComponent({
  props: {
    descriptionKey: {
      default: "page.configMetadata.modal.deleteModalDescription",
      type: String,
    },
    titleKey: {
      default: "page.configMetadata.modal.deleteModalHeadline",
      type: String,
    },
    open: {
      required: true,
      default: () => false,
      type: Boolean,
    },
    displayName: {
      default: "",
      type: String,
    },
  },

  emits: {
    clickDelete: null,
    close: null,
  },

  data() {
    return {
      isOpen: false,
      deleteName: "",
      inputState: false,
      showHelp: false,
    };
  },

  computed: {
    nameValid(): boolean | null {
      return this.deleteName && this.displayName
        ? this.deleteName.trim() === this.displayName.trim()
        : null;
    },
  },

  watch: {
    open() {
      this.isOpen = this.open;
    },
  },

  methods: {
    close() {
      this.isOpen = false;
    },
    hidden() {
      this.$emit("close");
    },
    clickDelete() {
      if (this.nameValid) {
        this.$emit("clickDelete");
      }
    },
  },
});
</script>

<style></style>
